<template>
  <transition name="fade">
    <div v-if="value" @keyup.enter="$emit('submitForm')">
      <div class="modal-wrapper">
        <div v-if="title" class="title">
          {{ title }}
        </div>
        <div class="body">
          <slot />
        </div>
        <div class="footer">
          <slot name="footer" />
        </div>
      </div>

      <div class="overlay" @click="closeModal()" />
    </div>
  </transition>
</template>

<script lang="ts">
import { defineComponent } from '@vue/composition-api';

export default defineComponent({
  name: 'Modal',
  emits: ['submitForm'],
  props: {
    title: {
      type: String,
      default: '',
    },
    value: {
      type: Boolean,
      default: false,
    },
  },
  setup(_, { emit }) {
    const closeModal = () => {
      emit('input', false);
    };

    return { closeModal };
  },
});
</script>

<style scoped lang="scss">
@import './Modal.scss';
</style>
